"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextFixEngine = void 0;
var textlint_engine_core_1 = require("./engine/textlint-engine-core");
var fixer_formatter_1 = require("@textlint/fixer-formatter");
/**
 * TextFixEngine a adapter for TextLintEngineCore.
 * It aim to pull the whole look together. (TextLintEngine and TextFixEngine)
 */
var TextFixEngine = /** @class */ (function (_super) {
    __extends(TextFixEngine, _super);
    function TextFixEngine() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * @param {TextLintCore} textlintCore
         * @returns {function()}
         */
        _this.onFile = function (textlintCore) {
            /**
             * Fixes the current configuration on an array of file and directory names.
             * TextFixEngine#executeOnFiles
             * @returns {TextlintFixResult[]} The results for all files that were linted.
             */
            return function (file) {
                return textlintCore.fixFile(file);
            };
        };
        /**
         * @param {TextLintCore} textlintCore
         * @returns {function()}
         */
        _this.onText = function (textlintCore) {
            /**
             * Fix texts with ext option.
             * TextFixEngine#executeOnText
             * @param {string} text linting text content
             * @param {string} [ext] ext is a type for linting. default: ".txt"
             * @returns {TextlintFixResult[]}
             */
            return function (text, ext) {
                return textlintCore.fixText(text, ext);
            };
        };
        /**
         * @param {TextLintFormatterOption} formatterConfig
         */
        _this.onFormat = function (formatterConfig) {
            return fixer_formatter_1.createFormatter(formatterConfig);
        };
        return _this;
    }
    return TextFixEngine;
}(textlint_engine_core_1.AbstractTextLintEngine));
exports.TextFixEngine = TextFixEngine;
//# sourceMappingURL=textfix-engine.js.map